package me.hekr.demo;

public class ReceiveMessageTask implements Runnable {
  private TcpClient tcpClient;
  private MessageListener messageListener;

  public ReceiveMessageTask(TcpClient tcpClient, MessageListener messageListener) {
    this.tcpClient = tcpClient;
    this.messageListener = messageListener;
  }

  @Override
  public void run() {
    String message;
    try {
      while (tcpClient.isOpen() && (message = tcpClient.receive()) != null) {
        messageListener.onMessage(message);
      }
    } catch (Exception e) {
      System.out.println(e.getMessage());
      tcpClient.close();
    }
  }
}
